/*---------------------------------------------------------------------------

   Swyx Solutions AG
   Joseph-von-Fraunhofer-Str. 13a
   44227 Dortmund

  ---------------------------------------------------------------------------

  THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY
  KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR
  PURPOSE.

  Copyright (C) 2007 Swyx Solutions AG.

  All Rights Reserved.

----------------------------------------------------------------------------*/


// PlugInSample.cpp : Implementation of DLL Exports.


// Note: Proxy/Stub Information
//      To build a separate proxy/stub DLL, 
//      run nmake -f PlugInSampleps.mk in the project directory.

#include "stdafx.h"
#include "resource.h"
#include <initguid.h>
#include "PlugInSample.h"
#include "..\..\..\PublicInterface\CLMgrPubTypes.h"
#include "MyResolver.h"
#include <comdef.h>


CComModule _Module;

BEGIN_OBJECT_MAP(ObjectMap)
OBJECT_ENTRY(CLSID_MyResolver, CMyResolver)
END_OBJECT_MAP()

class CPlugInSampleApp : public CWinApp
{
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPlugInSampleApp)
	public:
    virtual BOOL InitInstance();
    virtual int ExitInstance();
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CPlugInSampleApp)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

BEGIN_MESSAGE_MAP(CPlugInSampleApp, CWinApp)
	//{{AFX_MSG_MAP(CPlugInSampleApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

CPlugInSampleApp theApp;

BOOL CPlugInSampleApp::InitInstance()
{
    _Module.Init(ObjectMap, m_hInstance, &LIBID_PLUGINSAMPLELib);
    return CWinApp::InitInstance();
}

int CPlugInSampleApp::ExitInstance()
{
    _Module.Term();
    return CWinApp::ExitInstance();
}

/////////////////////////////////////////////////////////////////////////////
// Used to determine whether the DLL can be unloaded by OLE

STDAPI DllCanUnloadNow(void)
{
    AFX_MANAGE_STATE(AfxGetStaticModuleState());
    return (AfxDllCanUnloadNow()==S_OK && _Module.GetLockCount()==0) ? S_OK : S_FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// Returns a class factory to create an object of the requested type

STDAPI DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID* ppv)
{
    return _Module.GetClassObject(rclsid, riid, ppv);
}

/////////////////////////////////////////////////////////////////////////////
// DllRegisterServer - Adds entries to the system registry

STDAPI DllRegisterServer(void)
{
    CString sPlugInSection;
    BSTR    bstrCLSID;
    CString sGuid;

    if(StringFromCLSID(CLSID_MyResolver, &bstrCLSID)==S_OK)
    {
        sGuid=(char*)_bstr_t(bstrCLSID);
        sPlugInSection=CString("SOFTWARE\\Swyx\\Client Line Manager\\CurrentVersion\\Options\\PlugIns\\")+sGuid;

        HKEY hKey=NULL;

        if(RegCreateKey(HKEY_LOCAL_MACHINE, sPlugInSection, &hKey)==ERROR_SUCCESS)
        {
            CString sName;

            sName.LoadString(IDR_MAINFRAME);

            if(sName.IsEmpty())
            {
                sName="Unknown";
            }

            RegSetValueEx(hKey, "FriendlyName", 0, REG_SZ, (unsigned char*)(LPCTSTR)sName, sName.GetLength()+1);
            RegCloseKey(hKey);
        }

        CoTaskMemFree(bstrCLSID);

    }

    // registers object, typelib and all interfaces in typelib
    return _Module.RegisterServer(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// DllUnregisterServer - Removes entries from the system registry

STDAPI DllUnregisterServer(void)
{
    CString sPlugInSection;
    BSTR    bstrCLSID;
    CString sGuid;

    if(StringFromCLSID(CLSID_MyResolver, &bstrCLSID)==S_OK)
    {
        sGuid=(char*)_bstr_t(bstrCLSID);
        sPlugInSection=CString("SOFTWARE\\Swyx\\Client Line Manager\\CurrentVersion\\Options\\PlugIns\\")+sGuid;

        RegDeleteKey(HKEY_LOCAL_MACHINE, sPlugInSection);

        CoTaskMemFree(bstrCLSID);

    }

    return _Module.UnregisterServer(TRUE);
}


