/*---------------------------------------------------------------------------

   Swyx Solutions AG
   Joseph-von-Fraunhofer-Str. 13a
   44227 Dortmund

  ---------------------------------------------------------------------------

  THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY
  KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR
  PURPOSE.

  Copyright (C) 2007 Swyx Solutions AG.

  All Rights Reserved.

----------------------------------------------------------------------------*/

// MfcClientDlg.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "MfcClient.h"
#include "MfcClientDlg.h"




#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



//register window messages for signalling events to client
UINT glbWM_LineMgrNotification=RegisterWindowMessage(_T("WM_LineMgrNotification"));




/////////////////////////////////////////////////////////////////////////////
// CMfcClientDlg dialog
CMfcClientDlg::CMfcClientDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMfcClientDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMfcClientDlg)
	m_CallerID = _T("");
	m_bAcceptCalls = TRUE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

    //initialize interface pointer
    m_pICLMgr=NULL;
    m_pItemEventSink=NULL;
    m_adviseCookie=0;
}



CMfcClientDlg::~CMfcClientDlg()
{
}



void CMfcClientDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMfcClientDlg)
	DDX_Control(pDX, IDC_LIST_CALLS, m_CallList);
	DDX_Text(pDX, IDC_EDIT_CALLERID, m_CallerID);
	DDX_Check(pDX, IDC_CHECK_ACCEPTCALLS, m_bAcceptCalls);
	//}}AFX_DATA_MAP
}



BEGIN_MESSAGE_MAP(CMfcClientDlg, CDialog)
    //registered window message, send by client line manager
    ON_REGISTERED_MESSAGE(glbWM_LineMgrNotification, OnClientLineManagerEvent)

	//{{AFX_MSG_MAP(CMfcClientDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_CHECK_ACCEPTCALLS, OnCheckAcceptcalls)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()



BOOL CMfcClientDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

    m_CallList.InsertColumn(1, "Time");
    m_CallList.InsertColumn(2, "Connected");
    m_CallList.InsertColumn(3, "Peer Number / Name");
    m_CallList.InsertColumn(4, "Direction");
    m_CallList.InsertColumn(5, "Duration");
    m_CallList.InsertColumn(6, "Charging");
    m_CallList.InsertColumn(7, "CallID");

    m_CallList.SetColumnWidth(0, LVSCW_AUTOSIZE_USEHEADER);
    m_CallList.SetColumnWidth(1, LVSCW_AUTOSIZE_USEHEADER);
    m_CallList.SetColumnWidth(2, LVSCW_AUTOSIZE_USEHEADER);
    m_CallList.SetColumnWidth(3, LVSCW_AUTOSIZE_USEHEADER);
    m_CallList.SetColumnWidth(4, LVSCW_AUTOSIZE_USEHEADER);
    m_CallList.SetColumnWidth(5, LVSCW_AUTOSIZE_USEHEADER);
    m_CallList.SetColumnWidth(6, LVSCW_AUTOSIZE_USEHEADER);

    HRESULT hr;

    //create line manager object on local machine
    hr=CoCreateInstance(CLSID_ClientLineMgr, NULL, CLSCTX_LOCAL_SERVER, IID_IClientLineMgrPub,(void**)&m_pICLMgr);

    if(SUCCEEDED(hr))
    {
#ifdef USE_EVENT_SINK  //build targets "Win32 Debug Using Event Sink" and "Win32 Release Using Event Sink"

        if(m_pItemEventSink==NULL)
        {
            //connect our event sink to the line managers connection point (event source)
            IConnectionPointContainer   *pConnPtContainer;
            IConnectionPoint            *pConnectionPoint;

            hr=m_pICLMgr->QueryInterface(IID_IConnectionPointContainer,(void **)&pConnPtContainer);
            if(SUCCEEDED(hr))
            {
                //Find connection point for events you're interested in.
                hr=pConnPtContainer->FindConnectionPoint(IID_IClientLineMgrEventsDisp,&pConnectionPoint);
                if(SUCCEEDED(hr))
                {
                    m_pItemEventSink=new CCLMgrEventSink;
                    m_pItemEventSink->m_pMfcClientDlg=this;
                    //Get the IUnknown interface of your event implementation.
                    LPUNKNOWN pUnk=m_pItemEventSink->GetInterface(&IID_IUnknown);
                    if(pUnk!=0)
                    {
                        //connect to event source
                        hr=pConnectionPoint->Advise(pUnk, &m_adviseCookie);
                        if(FAILED(hr))
                        {
                            m_adviseCookie=0;
                            delete m_pItemEventSink;
                            m_pItemEventSink=NULL;
                        }
                    }
                    pConnectionPoint->Release();
                }
                pConnPtContainer->Release();
            }
        }


#else //build targets "Win32 Debug" and "Win32 Release"

        //register our window as target for client line manager messages
        hr=m_pICLMgr->PubRegisterMessageTarget((long)m_hWnd, 0);

#endif

    }        

	
	return TRUE;  // return TRUE  unless you set the focus to a control
}



// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.
void CMfcClientDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}



// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMfcClientDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}



void CMfcClientDlg::OnDestroy() 
{

#ifdef USE_EVENT_SINK  //build targets "Win32 Debug Using Event Sink" and "Win32 Release Using Event Sink"

    if(m_pItemEventSink)
    {
        m_pItemEventSink->m_pMfcClientDlg=NULL;
        if(m_adviseCookie && m_pICLMgr)
        {
            //disconnect our event sink from the line managers connection point (event source)
            IConnectionPointContainer   *pConnPtContainer;
            IConnectionPoint            *pConnectionPoint;
            HRESULT                     hr;

            hr=m_pICLMgr->QueryInterface(IID_IConnectionPointContainer,(void **)&pConnPtContainer);
            if(SUCCEEDED(hr))
            {
                //Find connection point for events you're interested in.
                hr=pConnPtContainer->FindConnectionPoint(IID_IClientLineMgrEventsDisp,&pConnectionPoint);
                if(SUCCEEDED(hr))
                {
                    //release connection to event source
                    hr=pConnectionPoint->Unadvise(m_adviseCookie);
                    pConnectionPoint->Release();
                }
                pConnPtContainer->Release();
            }
        }
        m_adviseCookie=0;
        delete m_pItemEventSink;
        m_pItemEventSink=NULL;
    }

#else //build targets "Win32 Debug" and "Win32 Release"

    if(m_pICLMgr)
    {
        HRESULT hr=m_pICLMgr->PubUnRegisterMessageTarget((long)m_hWnd, 0);
    }

#endif


    //release remaining interfaces
    if(m_pICLMgr)
    {
        m_pICLMgr->Release();
        m_pICLMgr=NULL;
    }


	CDialog::OnDestroy();
}



//used only in build targets "Win32 Debug" and "Win32 Release"
LRESULT CMfcClientDlg::OnClientLineManagerEvent(WPARAM wParam, LPARAM lParam)
{
    long            CLMgrMessage=wParam;
    _bstr_t         dialstring;
    int             iSignalledLine=-1;

    switch(CLMgrMessage)
    {

        case PubCLMgrLineStateChangedMessage:
            OnLineStateChanged(lParam);
            //so, now it's done; break here!
            break;
            
        case PubCLMgrCallDetailsMessage:
            OnLastCallDetails(lParam);
            //after disconnect: details about last call
            break;

        case PubCLMgrClientShutDownRequest:
        case PubCLMgrNumberOfLinesChangedMessage:
        case PubCLMgrLineSelectionChangedMessage:
        case PubCLMgrLineDetailsChangedMessage:
        case PubCLMgrGroupCallNotificationMessage:
        case PubCLMgrServerDownMessage:
        case PubCLMgrServerUpMessage:
        case PubCLMgrPowerSuspendMessage:
        case PubCLMgrPowerResumeMessage:
        case PubCLMgrUserDataChangedMessage:
        case PubCLMgrWaveDeviceChanged:
        case PubCLMgrHandsetStateChangedMessage:
        case PubCLMgrNameKeyStateChangedMessage:
        default:
            break;
    }

	return 0;
}



//state of a line has changed
void CMfcClientDlg::OnLineStateChanged(int iLine)
{
    HRESULT hr;

    IClientLinePub      *pILine=NULL;

    if(m_pICLMgr)    
    {
        hr=m_pICLMgr->PubGetLine(iLine, &pILine);

        if(SUCCEEDED(hr) && pILine)
        {
            long lState=PubLSNone;

            hr=pILine->PubGetState(&lState);

            switch(lState)
            {
                case PubLSRinging:
                    {
                        PubCLMgrLineDetails Details;

                        hr=pILine->PubGetDetails(&Details);

                        CString PeerName=Details.m_sPeerName;
                        CString PeerNumber=Details.m_sPeerNumber;

                        m_CallerID=PeerNumber;
                        if(PeerName!="")
                        {
                            m_CallerID+=CString(", ")+PeerName;
                        }

                        SysFreeString(Details.m_sAcknowledgedDialstring);
                        SysFreeString(Details.m_sPeerNumber);
                        SysFreeString(Details.m_sPeerName);
                        SysFreeString(Details.m_sCalledExtension);
                        SysFreeString(Details.m_sCalledName);
                        SysFreeString(Details.m_sRedirectedFromNumber);
                        SysFreeString(Details.m_sRedirectedFromName);
                        SysFreeString(Details.m_sBlindCallTransferSourceNumber);
                        SysFreeString(Details.m_sBlindCallTransferSourceName);
                        SysFreeString(Details.m_sChargingDetails);

                        if(m_bAcceptCalls)
                        {
                            hr=pILine->PubHookOff();
                        }
                    }
                    break;

                case PubLSTerminated:
                case PubLSBusy:
                case PubLSInactive:
                case PubLSHookOffInternal:
                case PubLSHookOffExternal:
                case PubLSDialing:
                case PubLSAlerting:
                case PubLSKnocking:
                case PubLSActive:
                case PubLSOnHold:
                case PubLSConferenceActive:
                case PubLSConferenceOnHold:
                case PubLSTransferring:
                case PubLSDisabled:
                default:
                    break;
            }

            pILine->Release();
        }
    }

    //init dialog with new data
    UpdateData(FALSE);
}



//there are details for a completed call available
void CMfcClientDlg::OnLastCallDetails(int iLine)
{
    HRESULT hr;

    IClientLinePub      *pILine=NULL;

    if(m_pICLMgr)    
    {
        hr=m_pICLMgr->PubGetLine(iLine, &pILine);

        if(SUCCEEDED(hr) && pILine)
        {
            IClientLinePub2 *pIClientLinePub2=NULL;

            hr=pILine->QueryInterface(IID_IClientLinePub2, (void**)&pIClientLinePub2);

            if(SUCCEEDED(hr) && pIClientLinePub2)
            {
                PubCLMgrCallDetailsEx LastCallDetails;
                memset(&LastCallDetails,0,sizeof(PubCLMgrCallDetailsEx));
                LastCallDetails.m_LastCallHistoryItemsArraySize=0;

                hr=pIClientLinePub2->PubGetLastCallDetailsEx(&LastCallDetails);
                if(SUCCEEDED(hr))
                {
                    CTime StartTime=CTime(  LastCallDetails.m_LastCallStartTime.year,
                                            LastCallDetails.m_LastCallStartTime.month,
                                            LastCallDetails.m_LastCallStartTime.day,
                                            LastCallDetails.m_LastCallStartTime.hour,
                                            LastCallDetails.m_LastCallStartTime.minute,
                                            LastCallDetails.m_LastCallStartTime.second);

                    CTime EndTime=CTime(    LastCallDetails.m_LastCallFinishedTime.year,
                                            LastCallDetails.m_LastCallFinishedTime.month,
                                            LastCallDetails.m_LastCallFinishedTime.day,
                                            LastCallDetails.m_LastCallFinishedTime.hour,
                                            LastCallDetails.m_LastCallFinishedTime.minute,
                                            LastCallDetails.m_LastCallFinishedTime.second);

                    CTimeSpan Duration=EndTime-StartTime;

                    CString PeerName=LastCallDetails.m_sLastCallPeersPbxUserName;
                    CString PeerNumber=LastCallDetails.m_sLastCallPeersNumber;
                    CString Peer=PeerNumber;

                    if(PeerName!="")
                    {
                        Peer+=CString(", ")+PeerName;
                    }

                    CString Charging=LastCallDetails.m_sLastCallChargingDetails;
                    CString CallId;

                    CallId.Format("%u", LastCallDetails.m_LastCallId);

                    LastCallDetails.m_LastCallIsOutgoing;
                    LastCallDetails.m_LastCallWasConnected;

                

                    int index=m_CallList.InsertItem(m_CallList.GetItemCount(), StartTime.Format("%c"));

                    m_CallList.SetItemText(index, 1, LastCallDetails.m_LastCallWasConnected?"Yes":"No");
                    m_CallList.SetItemText(index, 2, Peer);
                    m_CallList.SetItemText(index, 3, LastCallDetails.m_LastCallIsOutgoing?"Out":"In");
                    m_CallList.SetItemText(index, 4, Duration.Format("%H:%M:%S"));
                    m_CallList.SetItemText(index, 5, Charging);
                    m_CallList.SetItemText(index, 6, CallId);

                    SysFreeString(LastCallDetails.m_sLastCallLcrPrefix);
                    SysFreeString(LastCallDetails.m_sLastCallOriginatingExtension);
                    SysFreeString(LastCallDetails.m_sLastCallChargingDetails);
                    SysFreeString(LastCallDetails.m_sLastCallPeersPbxUserName);
                    SysFreeString(LastCallDetails.m_sLastCallPeersNumber);

                    m_CallList.SetColumnWidth(0, LVSCW_AUTOSIZE);

                }
                pIClientLinePub2->Release();
            }

            pILine->Release();
        }
    }

    //init dialog with new data
    UpdateData(FALSE);
   
}




void CMfcClientDlg::OnCheckAcceptcalls() 
{
    //get data
    UpdateData(TRUE);
}
