/*---------------------------------------------------------------------------

   Swyx Solutions AG
   Joseph-von-Fraunhofer-Str. 13a
   44227 Dortmund

  ---------------------------------------------------------------------------

  THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY
  KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR
  PURPOSE.

  Copyright (C) 2007 Swyx Solutions AG.

  All Rights Reserved.

----------------------------------------------------------------------------*/
// PlayToRtpDlg.cpp : implementation file
//

#include "stdafx.h"
#include "..\..\..\PublicInterface\CLMgrPubTypes.h"
#include "CLMgrPub.h"
#include "PlayToRtp.h"
#include "PlayToRtpDlg.h"
#include <comdef.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPlayToRtpDlg dialog

CPlayToRtpDlg::CPlayToRtpDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPlayToRtpDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPlayToRtpDlg)
	m_bPlayLoop = FALSE;
	m_bRecordAppend = FALSE;
	m_bRecordLocalSounds = FALSE;
	m_sPlayFile = _T("");
	m_uiPlayPause = 0;
	m_sRecordFile = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
    m_pIClientLineMgrPub3=NULL;
    m_bPlaying=FALSE;
    m_bRecording=FALSE;
}

void CPlayToRtpDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPlayToRtpDlg)
	DDX_Check(pDX, IDC_CHECK_PLAYLOOP, m_bPlayLoop);
	DDX_Check(pDX, IDC_CHECK_RECORDAPPEND, m_bRecordAppend);
	DDX_Check(pDX, IDC_CHECK_RECORDLOCALSOUNDS, m_bRecordLocalSounds);
	DDX_Text(pDX, IDC_EDIT_PLAYFILE, m_sPlayFile);
	DDX_Text(pDX, IDC_EDIT_PLAYPAUSE, m_uiPlayPause);
	DDX_Text(pDX, IDC_EDIT_RECORDFILE, m_sRecordFile);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPlayToRtpDlg, CDialog)
	//{{AFX_MSG_MAP(CPlayToRtpDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_STARTPLAY, OnButtonStartplay)
	ON_BN_CLICKED(IDC_BUTTON_STARTRECORD, OnButtonStartrecord)
	ON_BN_CLICKED(IDC_BUTTON_STOPPLAY, OnButtonStopplay)
	ON_BN_CLICKED(IDC_BUTTON_STOPRECORD, OnButtonStoprecord)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPlayToRtpDlg message handlers

BOOL CPlayToRtpDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

    HRESULT hr=CoCreateInstance(CLSID_ClientLineMgr, NULL, CLSCTX_ALL, IID_IClientLineMgrPub3, (void**)&m_pIClientLineMgrPub3);

    if(FAILED(hr))
    {
        m_pIClientLineMgrPub3=NULL;
    }

    GetDlgItem(IDC_BUTTON_STARTPLAY)->EnableWindow(!m_bPlaying);
    GetDlgItem(IDC_BUTTON_STOPPLAY)->EnableWindow(m_bPlaying);
    GetDlgItem(IDC_BUTTON_STARTRECORD)->EnableWindow(!m_bRecording);
    GetDlgItem(IDC_BUTTON_STOPRECORD)->EnableWindow(m_bRecording);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPlayToRtpDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPlayToRtpDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CPlayToRtpDlg::OnButtonStartplay() 
{

    UpdateData(TRUE);
    _bstr_t sPath=m_sPlayFile;
	
    if(m_pIClientLineMgrPub3)
    {
    	m_pIClientLineMgrPub3->PubStopPlayToRtp();
        m_bPlaying=m_pIClientLineMgrPub3->PubPlayToRtp(sPath, m_bPlayLoop, m_uiPlayPause) == S_OK;
    }

    GetDlgItem(IDC_BUTTON_STARTPLAY)->EnableWindow(!m_bPlaying);
    GetDlgItem(IDC_BUTTON_STOPPLAY)->EnableWindow(m_bPlaying);
}

void CPlayToRtpDlg::OnButtonStartrecord() 
{

    UpdateData(TRUE);
    _bstr_t sPath=m_sRecordFile;

    if(m_pIClientLineMgrPub3)
    {
    	m_pIClientLineMgrPub3->PubStopRecordFromRtp();
        m_bRecording=m_pIClientLineMgrPub3->PubRecordFromRtp(sPath, m_bRecordAppend, m_bRecordLocalSounds) == S_OK;
    }
	
    GetDlgItem(IDC_BUTTON_STARTRECORD)->EnableWindow(!m_bRecording);
    GetDlgItem(IDC_BUTTON_STOPRECORD)->EnableWindow(m_bRecording);
}

void CPlayToRtpDlg::OnButtonStopplay() 
{
    if(m_pIClientLineMgrPub3)
    {
    	m_pIClientLineMgrPub3->PubStopPlayToRtp();
    }
    m_bPlaying=FALSE;

    GetDlgItem(IDC_BUTTON_STARTPLAY)->EnableWindow(!m_bPlaying);
    GetDlgItem(IDC_BUTTON_STOPPLAY)->EnableWindow(m_bPlaying);
}

void CPlayToRtpDlg::OnButtonStoprecord() 
{
    if(m_pIClientLineMgrPub3)
    {
    	m_pIClientLineMgrPub3->PubStopRecordFromRtp();
    }
    m_bRecording=FALSE;

    GetDlgItem(IDC_BUTTON_STARTRECORD)->EnableWindow(!m_bRecording);
    GetDlgItem(IDC_BUTTON_STOPRECORD)->EnableWindow(m_bRecording);
}

void CPlayToRtpDlg::OnDestroy() 
{
	CDialog::OnDestroy();

    if(m_pIClientLineMgrPub3)
    {
    	m_pIClientLineMgrPub3->PubStopPlayToRtp();
    	m_pIClientLineMgrPub3->PubStopRecordFromRtp();

        m_pIClientLineMgrPub3->Release();
        m_pIClientLineMgrPub3=NULL;
    }
	
}
