/*---------------------------------------------------------------------------

   Swyx Solutions AG
   Joseph-von-Fraunhofer-Str. 13a
   44227 Dortmund

  ---------------------------------------------------------------------------

  THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY
  KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR
  PURPOSE.

  Copyright (C) 2007 Swyx Solutions AG.

  All Rights Reserved.

----------------------------------------------------------------------------*/

// CLMgrEventSink.cpp : implementation file
//

#include "stdafx.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



/////////////////////////////////////////////////////////////////////////////
// CCLMgrEventSink



IMPLEMENT_DYNCREATE(CCLMgrEventSink, CCmdTarget)



CCLMgrEventSink::CCLMgrEventSink()
{
	EnableAutomation();
    m_pMfcClientDlg=NULL;
}



CCLMgrEventSink::~CCLMgrEventSink()
{
}



void CCLMgrEventSink::OnFinalRelease()
{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// delete the object. Add additional cleanup required for your
	// object before calling the base class.
	CCmdTarget::OnFinalRelease();
}



BEGIN_MESSAGE_MAP(CCLMgrEventSink, CCmdTarget)
	//{{AFX_MSG_MAP(CCLMgrEventSink)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()



BEGIN_DISPATCH_MAP(CCLMgrEventSink, CCmdTarget)
	//{{AFX_DISPATCH_MAP(CCLMgrEventSink)
	DISP_FUNCTION(CCLMgrEventSink, "DispOnLineMgrNotification", DispOnLineMgrNotification, VT_EMPTY, VTS_I4 VTS_I4)
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()



//  Note: we add support for IID_IClientLineMgrEventsDisp to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .ODL file.
//  {f8e55365-4c00-11d3-80bc-00105a653379}

const IID IID_IClientLineMgrEventsDisp={0xf8e55365, 0x4c00, 0x11d3, { 0x80, 0xbc, 0x00, 0x10, 0x5a, 0x65, 0x33, 0x79 }};



BEGIN_INTERFACE_MAP(CCLMgrEventSink, CCmdTarget)
	INTERFACE_PART(CCLMgrEventSink, IID_IClientLineMgrEventsDisp, Dispatch)
END_INTERFACE_MAP()



/////////////////////////////////////////////////////////////////////////////
// CCLMgrEventSink message handlers



void CCLMgrEventSink::DispOnLineMgrNotification(long msg, long param) 
{
	if(m_pMfcClientDlg)
    {
        switch(msg)
        {
            case PubCLMgrLineStateChangedMessage:
                //state of a line has changed. lParam: index of line
                m_pMfcClientDlg->OnLineStateChanged(param);
                break;

            case PubCLMgrLineSelectionChangedMessage:
                //line in focus has changed
                //lParam: index of now selected line
                m_pMfcClientDlg->OnLineSelectionChanged(param);
                break;

            case PubCLMgrLineDetailsChangedMessage:
                //details of line has changed
                //lParam: index of line
                m_pMfcClientDlg->OnLineDetailsChanged(param);
                break;

            case PubCLMgrCallDetailsMessage:
                //details of last call are available, after disconnect, for logging purpose
                //lParam: index of line           
                m_pMfcClientDlg->OnLastCallDetails(param);
                break;

            case PubCLMgrNumberOfLinesChangedMessage:
                //the number of lines has changed
                //lParam: new number of lines
                m_pMfcClientDlg->OnNumberOfLinesChanged(param);
                break;

            case PubCLMgrClientShutDownRequest:
                //Client Line Manager requests client to shutdown and release all interfaces
                m_pMfcClientDlg->OnClientShutDownRequest();
                break;

            case PubCLMgrHandsetStateChangedMessage:
            case PubCLMgrNameKeyStateChangedMessage:
            case PubCLMgrUserDataChangedMessage:
            case PubCLMgrGroupCallNotificationMessage:
            case PubCLMgrServerDownMessage:
            case PubCLMgrServerUpMessage:
            case PubCLMgrWaveDeviceChanged:
            case PubCLMgrPowerSuspendMessage:
            case PubCLMgrPowerResumeMessage:
            default:
                break;
        }
    }
}
