/*---------------------------------------------------------------------------

   Swyx Solutions AG
   Joseph-von-Fraunhofer-Str. 13a
   44227 Dortmund

  ---------------------------------------------------------------------------

  THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY
  KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR
  PURPOSE.

  Copyright (C) 2007 Swyx Solutions AG.

  All Rights Reserved.

----------------------------------------------------------------------------*/

// MfcClientDlg.cpp : implementation file
//

#include "stdafx.h"




#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



//register window messages for signalling events to client
UINT glbWM_LineMgrNotification=RegisterWindowMessage(_T("WM_LineMgrNotification"));




/////////////////////////////////////////////////////////////////////////////
// CMfcClientDlg dialog
CMfcClientDlg::CMfcClientDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMfcClientDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMfcClientDlg)
	m_ServerName = _T("");
	m_UserName = _T("");
	m_iSelectedLine = 0;
	m_szSelectedLineState = _T("");
	m_szDialstring = _T("");
	m_szSelectedLineCharging = _T("");
	m_szSelectedLinePeerName = _T("");
	m_szSelectedLinePeerNumber = _T("");
	m_szSelectedLineDisconnectReason = _T("");
	m_szSelectedLineDialed = _T("");
	m_szCallHistory = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

    //initialize interface pointer
    m_pICLMgr=NULL;
    m_pISelectedLine=NULL;
    m_iSelectedLine=-1;
    m_iNumberOfLines=0;
    m_pItemEventSink=NULL;
    m_adviseCookie=0;
}



CMfcClientDlg::~CMfcClientDlg()
{
    //if interfaces still living, release 'em
    if(m_pICLMgr)
    {
        m_pICLMgr->Release();
        m_pICLMgr=NULL;
    }

    if(m_pISelectedLine)
    {
        m_pISelectedLine->Release();
        m_pISelectedLine=NULL;
    }
}



void CMfcClientDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMfcClientDlg)
	DDX_Text(pDX, IDC_EDIT_SERVERNAME, m_ServerName);
	DDX_Text(pDX, IDC_EDIT_USERNAME, m_UserName);
	DDX_Text(pDX, IDC_EDIT_SELLINE_INDEX, m_iSelectedLine);
	DDX_Text(pDX, IDC_EDIT_SELLINE_STATE, m_szSelectedLineState);
	DDX_Text(pDX, IDC_EDIT_DIALSTRING, m_szDialstring);
	DDV_MaxChars(pDX, m_szDialstring, 30);
	DDX_Text(pDX, IDC_EDIT_SELLINE_CHARGING, m_szSelectedLineCharging);
	DDX_Text(pDX, IDC_EDIT_SELLINE_PEERNAME, m_szSelectedLinePeerName);
	DDX_Text(pDX, IDC_EDIT_SELLINE_PEERNUMBER, m_szSelectedLinePeerNumber);
	DDX_Text(pDX, IDC_EDIT_SELLINE_DISCONNECTREASON, m_szSelectedLineDisconnectReason);
	DDX_Text(pDX, IDC_EDIT_SELLINE_DIALED, m_szSelectedLineDialed);
	DDX_Text(pDX, IDC_EDIT_CALLHIST, m_szCallHistory);
	//}}AFX_DATA_MAP
}



BEGIN_MESSAGE_MAP(CMfcClientDlg, CDialog)
    //registered window message, send by client line manager
    ON_REGISTERED_MESSAGE(glbWM_LineMgrNotification, OnClientLineManagerEvent)

	//{{AFX_MSG_MAP(CMfcClientDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_LOGON, OnButtonLogon)
	ON_BN_CLICKED(IDC_BUTTON_LOGOFF, OnButtonLogoff)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_DIAL, OnButtonDial)
	ON_BN_CLICKED(IDC_BUTTON_HOLD, OnButtonHold)
	ON_BN_CLICKED(IDC_BUTTON_HOOKOFF, OnButtonHookoff)
	ON_BN_CLICKED(IDC_BUTTON_HOOKON, OnButtonHookon)
	ON_BN_CLICKED(IDC_BUTTON_PRESSHOOK, OnButtonPresshook)
	ON_BN_CLICKED(IDC_BUTTON_SWITCH, OnButtonSwitch)
	ON_BN_CLICKED(IDC_BUTTON_ACTIVATE, OnButtonActivate)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()



BOOL CMfcClientDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

    //feedback: enable / disable logon and logoff button
    GetDlgItem(IDC_BUTTON_LOGON)->EnableWindow(TRUE);
    GetDlgItem(IDC_BUTTON_LOGOFF)->EnableWindow(FALSE);
	
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}



// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.
void CMfcClientDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}



// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMfcClientDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}



//user clicked on button logon -> load line manager and register on server
void CMfcClientDlg::OnButtonLogon() 
{
    HRESULT hr;
    _bstr_t bstrServerName;
    _bstr_t bstrUserName;
    bool bLoggedOn=false;

    //get data from dialog
    UpdateData(TRUE);

    //feedback: enable / disable logon and logoff button
    GetDlgItem(IDC_BUTTON_LOGON)->EnableWindow(FALSE);
    GetDlgItem(IDC_BUTTON_LOGOFF)->EnableWindow(FALSE);

    


    //create line manager object on local machine
    hr=CoCreateInstance(CLSID_ClientLineMgr, NULL, CLSCTX_LOCAL_SERVER, IID_IClientLineMgrPub,(void**)&m_pICLMgr);

    if(SUCCEEDED(hr))
    {
        IClientLineMgrDisp* pIClientLineMgrDisp=NULL;

        hr=m_pICLMgr->QueryInterface(IID_IClientLineMgrDisp, (void**)&pIClientLineMgrDisp);

        if( (hr==S_OK) && (pIClientLineMgrDisp!=NULL) )
        {

#ifdef USE_EVENT_SINK  //build targets "Win32 Debug Using Event Sink" and "Win32 Release Using Event Sink"

            if(m_pItemEventSink==NULL)
            {
                //connect our event sink to the line managers connection point (event source)
                IConnectionPointContainer   *pConnPtContainer;
                IConnectionPoint            *pConnectionPoint;

                hr=m_pICLMgr->QueryInterface(IID_IConnectionPointContainer,(void **)&pConnPtContainer);
                if(SUCCEEDED(hr))
                {
                    //Find connection point for events you're interested in.
                    hr=pConnPtContainer->FindConnectionPoint(IID_IClientLineMgrEventsDisp,&pConnectionPoint);
                    if(SUCCEEDED(hr))
                    {
                        m_pItemEventSink=new CCLMgrEventSink;
                        m_pItemEventSink->m_pMfcClientDlg=this;
                        //Get the IUnknown interface of your event implementation.
                        LPUNKNOWN pUnk=m_pItemEventSink->GetInterface(&IID_IUnknown);
                        if(pUnk!=0)
                        {
                            //connect to event source
                            hr=pConnectionPoint->Advise(pUnk, &m_adviseCookie);
                            if(FAILED(hr))
                            {
                                m_adviseCookie=0;
                                delete m_pItemEventSink;
                                m_pItemEventSink=NULL;
                            }
                        }
                        pConnectionPoint->Release();
                    }
                    pConnPtContainer->Release();
                }
            }


#else //build targets "Win32 Debug" and "Win32 Release"

            //register our window as target for client line manager messages
            hr=m_pICLMgr->PubRegisterMessageTarget((long)m_hWnd, 0);

#endif

            //logon as user
            bstrServerName=m_ServerName;
            bstrUserName=m_UserName;

            BSTR bstrAmbiguousUsernames=NULL;

            hr=pIClientLineMgrDisp->RegisterUserEx(bstrServerName, NULL, bstrUserName, NULL, 2, FALSE, &bstrAmbiguousUsernames);

            if( (hr==S_OK) && (bstrAmbiguousUsernames==NULL))
            {
                bLoggedOn=true;
                //trusted logon succeeded, Logon was ambiguous
                hr=m_pICLMgr->PubGetNumberOfLines((long*)&m_iNumberOfLines);
                hr=m_pICLMgr->PubGetSelectedLine(&m_pISelectedLine);
                hr=m_pICLMgr->PubGetSelectedLineNumber((long*)&m_iSelectedLine);

                if( (m_iSelectedLine>=0) && (m_iSelectedLine<m_iNumberOfLines))
                {
                    //fake line manager event in order to get dialog filles
                    OnClientLineManagerEvent(PubCLMgrLineSelectionChangedMessage, m_iSelectedLine);
                }
            }

            if(!bLoggedOn)
            {

#ifdef USE_EVENT_SINK  //build targets "Win32 Debug Using Event Sink" and "Win32 Release Using Event Sink"

                if(m_pItemEventSink)
                {
                    m_pItemEventSink->m_pMfcClientDlg=NULL;
                    if(m_adviseCookie && m_pICLMgr)
                    {
                        //disconnect our event sink from the line managers connection point (event source)
                        IConnectionPointContainer   *pConnPtContainer;
                        IConnectionPoint            *pConnectionPoint;
                        HRESULT                     hr;

                        hr=m_pICLMgr->QueryInterface(IID_IConnectionPointContainer,(void **)&pConnPtContainer);
                        if(SUCCEEDED(hr))
                        {
                            //Find connection point for events you're interested in.
                            hr=pConnPtContainer->FindConnectionPoint(IID_IClientLineMgrEventsDisp,&pConnectionPoint);
                            if(SUCCEEDED(hr))
                            {
                                //release connection to event source
                                hr=pConnectionPoint->Unadvise(m_adviseCookie);
                                pConnectionPoint->Release();
                            }
                            pConnPtContainer->Release();
                        }
                    }
                    m_adviseCookie=0;
                    delete m_pItemEventSink;
                    m_pItemEventSink=NULL;
                }

#else //build targets "Win32 Debug" and "Win32 Release"

                if(m_pICLMgr)
                {
                    hr=m_pICLMgr->PubUnRegisterMessageTarget((long)m_hWnd, 0);
                }

#endif




                m_pICLMgr->Release();
                m_pICLMgr=NULL;
            }

            pIClientLineMgrDisp->Release();
            pIClientLineMgrDisp=NULL;
        }
        else
        {
            m_pICLMgr->Release();
            m_pICLMgr=NULL;
        }
    }        

    //feedback: enable / disable logon and logoff button
    if(bLoggedOn)
    {
        GetDlgItem(IDC_BUTTON_LOGON)->EnableWindow(FALSE);
        GetDlgItem(IDC_BUTTON_LOGOFF)->EnableWindow(TRUE);
    }
    else
    {
        GetDlgItem(IDC_BUTTON_LOGON)->EnableWindow(TRUE);
        GetDlgItem(IDC_BUTTON_LOGOFF)->EnableWindow(FALSE);
    }
}



//user clicked on button logoff -> unregister from server and release references to line manager
void CMfcClientDlg::OnButtonLogoff() 
{
    HRESULT hr;


#ifdef USE_EVENT_SINK  //build targets "Win32 Debug Using Event Sink" and "Win32 Release Using Event Sink"

    if(m_pItemEventSink)
    {
        m_pItemEventSink->m_pMfcClientDlg=NULL;
        if(m_adviseCookie && m_pICLMgr)
        {
            //disconnect our event sink from the line managers connection point (event source)
            IConnectionPointContainer   *pConnPtContainer;
            IConnectionPoint            *pConnectionPoint;
            HRESULT                     hr;

            hr=m_pICLMgr->QueryInterface(IID_IConnectionPointContainer,(void **)&pConnPtContainer);
            if(SUCCEEDED(hr))
            {
                //Find connection point for events you're interested in.
                hr=pConnPtContainer->FindConnectionPoint(IID_IClientLineMgrEventsDisp,&pConnectionPoint);
                if(SUCCEEDED(hr))
                {
                    //release connection to event source
                    hr=pConnectionPoint->Unadvise(m_adviseCookie);
                    pConnectionPoint->Release();
                }
                pConnPtContainer->Release();
            }
        }
        m_adviseCookie=0;
        delete m_pItemEventSink;
        m_pItemEventSink=NULL;
    }

#else //build targets "Win32 Debug" and "Win32 Release"

    if(m_pICLMgr)
    {
        hr=m_pICLMgr->PubUnRegisterMessageTarget((long)m_hWnd, 0);
    }

#endif


    //registered on server?
    if(m_pICLMgr)
    {
        IClientLineMgrDisp* pIClientLineMgrDisp=NULL;

        hr=m_pICLMgr->QueryInterface(IID_IClientLineMgrDisp, (void**)&pIClientLineMgrDisp);

        if( (hr==S_OK) && (pIClientLineMgrDisp!=NULL) )
        {
            hr=pIClientLineMgrDisp->ReleaseUserEx();
            pIClientLineMgrDisp->Release();
            pIClientLineMgrDisp=NULL;
        }
    }

    //release remaining interfaces
    if(m_pICLMgr)
    {
        m_pICLMgr->Release();
        m_pICLMgr=NULL;
    }

    if(m_pISelectedLine)
    {
        m_pISelectedLine->Release();
        m_pISelectedLine=NULL;
    }

    //feedback: enable / disable logon and logoff button
    GetDlgItem(IDC_BUTTON_LOGON)->EnableWindow(TRUE);
    GetDlgItem(IDC_BUTTON_LOGOFF)->EnableWindow(FALSE);

}



void CMfcClientDlg::OnDestroy() 
{
    //logoff, just to be sure
	OnButtonLogoff();

	CDialog::OnDestroy();
}



//used only in build targets "Win32 Debug" and "Win32 Release"
LRESULT CMfcClientDlg::OnClientLineManagerEvent(WPARAM wParam, LPARAM lParam)
{
    long            CLMgrMessage=wParam;
    _bstr_t         dialstring;
    int             iSignalledLine=-1;

    switch(CLMgrMessage)
    {
        case PubCLMgrLineSelectionChangedMessage:
            OnLineSelectionChanged(lParam);
            //no break here!!!
            //I know it's dirty, but to get quick sample code we just go on with
            //handling of next case: get details of that line for display
            
        case PubCLMgrLineDetailsChangedMessage:
            OnLineDetailsChanged(lParam);
            //no break here!!!
            //I know it's dirty, but to get quick sample code we just go on with
            //handling of next case: get (new) state of that line for display

        case PubCLMgrLineStateChangedMessage:
            OnLineStateChanged(lParam);
            //so, now it's done; break here!
            break;
            
        case PubCLMgrCallDetailsMessage:
            OnLastCallDetails(lParam);
            //after disconnect: details about last call
            break;

        case PubCLMgrNumberOfLinesChangedMessage:
            //number of lines has changed!
            OnNumberOfLinesChanged(lParam);
            break;

        case PubCLMgrClientShutDownRequest:
            //we are requested to logoff
            //be a good client and do it! thanks!
        	OnButtonLogoff();
            break;

        case PubCLMgrGroupCallNotificationMessage:
        case PubCLMgrServerDownMessage:
        case PubCLMgrServerUpMessage:
        case PubCLMgrPowerSuspendMessage:
        case PubCLMgrPowerResumeMessage:
        case PubCLMgrUserDataChangedMessage:
        case PubCLMgrWaveDeviceChanged:
        case PubCLMgrHandsetStateChangedMessage:
        case PubCLMgrNameKeyStateChangedMessage:
        default:
            break;
    }

	return 0;
}



void CMfcClientDlg::OnButtonHookoff() 
{
    if(m_pISelectedLine)
    {
        m_pISelectedLine->PubHookOff();
    }
}



void CMfcClientDlg::OnButtonHookon() 
{
    if(m_pISelectedLine)
    {
        m_pISelectedLine->PubHookOn();
    }
}



void CMfcClientDlg::OnButtonPresshook() 
{
    if(m_pISelectedLine)
    {
        m_pISelectedLine->PubPressHook();
    }
}



void CMfcClientDlg::OnButtonDial() 
{
    HRESULT hr;

    //get data from dialog
    UpdateData(TRUE);

    if(m_pISelectedLine)
    {
        _bstr_t bstr_dummy=m_szDialstring;
        hr=m_pISelectedLine->PubDial(bstr_dummy);
        if(SUCCEEDED(hr))
        {
            m_szDialstring=_T("");
            //write data to dialog
            UpdateData(FALSE);
        }
    }
}



void CMfcClientDlg::OnButtonSwitch() 
{
    HRESULT hr;
    long iNextLine=m_iSelectedLine+1;

    if(iNextLine>=m_iNumberOfLines)
    {
        iNextLine=0;
    }

    if(m_pICLMgr)
    {
        hr=m_pICLMgr->PubSelectLineNumber(iNextLine);
    }
}



void CMfcClientDlg::OnButtonHold() 
{
    if(m_pISelectedLine)
    {
        m_pISelectedLine->PubHold();
    }
}



void CMfcClientDlg::OnButtonActivate() 
{
    if(m_pISelectedLine)
    {
        m_pISelectedLine->PubActivate();
    }
}



//state of a line has changed
void CMfcClientDlg::OnLineStateChanged(int iLine)
{
    HRESULT hr;

    //get data from dialog (in order to preserve dialstring)
    UpdateData(TRUE);
    
    if((iLine>=0) && (iLine<m_iNumberOfLines) && (iLine==m_iSelectedLine))
    {
        //line state changed on selected line
        if(m_pISelectedLine)
        {
            //get new state
            m_pISelectedLine->PubGetState((long*)&m_iSelectedLineState);
            if((m_iSelectedLineState>=PubLSInactive) && (m_iSelectedLineState<=PubLSDisabled))
            {
                m_szSelectedLineState.LoadString(ID_LS_INACTIVE+(m_iSelectedLineState-PubLSInactive));
            }

            switch(m_iSelectedLineState)
            {
                case PubLSTerminated:
                case PubLSBusy:
                    {
                        PubCLMgrLineDetails Details;

                        hr=m_pISelectedLine->PubGetDetails(&Details);

                        if((Details.m_DiscReason>=PubSCl3DRNormal) && (Details.m_DiscReason<=PubSCl3DRIncompatibleDestination))
                        {
                            m_szSelectedLineDisconnectReason.LoadString(IDS_DISC_NORMAL+Details.m_DiscReason-PubSCl3DRNormal);
                        }
                        else
                        {
                            m_szSelectedLineDisconnectReason=_T("???");
                        }

                        SysFreeString(Details.m_sAcknowledgedDialstring);
                        SysFreeString(Details.m_sPeerNumber);
                        SysFreeString(Details.m_sPeerName);
                        SysFreeString(Details.m_sCalledExtension);
                        SysFreeString(Details.m_sCalledName);
                        SysFreeString(Details.m_sRedirectedFromNumber);
                        SysFreeString(Details.m_sRedirectedFromName);
                        SysFreeString(Details.m_sBlindCallTransferSourceNumber);
                        SysFreeString(Details.m_sBlindCallTransferSourceName);
                        SysFreeString(Details.m_sChargingDetails);
                    }
                    break;

                case PubLSInactive:
                case PubLSHookOffInternal:
                case PubLSHookOffExternal:
                case PubLSRinging:
                case PubLSDialing:
                case PubLSAlerting:
                case PubLSKnocking:
                case PubLSActive:
                case PubLSOnHold:
                case PubLSConferenceActive:
                case PubLSConferenceOnHold:
                case PubLSTransferring:
                case PubLSDisabled:
                default:
                    m_szSelectedLineDisconnectReason=_T("");
                    break;
            }
        }
    }

    //init dialog with new data
    UpdateData(FALSE);
}



//line in focus has changed
void CMfcClientDlg::OnLineSelectionChanged(int iLine)
{
    HRESULT hr;

    //get data from dialog (in order to preserve dialstring)
    UpdateData(TRUE);

    if((iLine>=0) && (iLine<m_iNumberOfLines) && (iLine!=m_iSelectedLine))
    {
        //selected line changed
        if(m_pISelectedLine)
        {
            m_pISelectedLine->Release();
            m_pISelectedLine=NULL;
        }
        hr=m_pICLMgr->PubGetSelectedLine(&m_pISelectedLine);
        hr=m_pICLMgr->PubGetSelectedLineNumber((long*)&m_iSelectedLine);
    }

    //init dialog with new data
    UpdateData(FALSE);
}



//details of line has changed
void CMfcClientDlg::OnLineDetailsChanged(int iLine)
{
    HRESULT hr;

    //get data from dialog (in order to preserve dialstring)
    UpdateData(TRUE);
    
    if((iLine>=0) && (iLine<m_iNumberOfLines) && (iLine==m_iSelectedLine))
    {
        //line details changed on selected line
        if(m_pISelectedLine)
        {
            IClientLinePub2 *pIClientLinePub2=NULL;
            PubCLMgrLineDetailsEx *pDetailsEx3=NULL;

            hr=m_pISelectedLine->QueryInterface(IID_IClientLinePub2, (void**)&pIClientLinePub2);

            if(SUCCEEDED(hr) && pIClientLinePub2)
            {
                //SwyxIt! 4.10 or later
                static int iHistorySize=30;

                int DetailsEx3Size=sizeof(PubCLMgrLineDetailsEx)+sizeof(PubCLMgrCallHistoryItem)*iHistorySize;

                pDetailsEx3=reinterpret_cast<PubCLMgrLineDetailsEx*>(CoTaskMemAlloc(DetailsEx3Size));

                if(pDetailsEx3)
                {
                    memset(pDetailsEx3,0,DetailsEx3Size);
                    pDetailsEx3->m_HistoryItemsArraySize=iHistorySize;

                    hr=pIClientLinePub2->PubGetDetailsEx(pDetailsEx3);

                    if(hr==S_OK)
                    {
                        CString szNewValue;

                        if(pDetailsEx3->m_NumHistoryItemsAvailable > iHistorySize-10 )
                        {
                            //danger, array will be soon too small
                            //use larger array next time
                            iHistorySize+=10;
                        }
            
                        if(pDetailsEx3->m_sAcknowledgedDialstring)
                        {
                            m_szSelectedLineDialed=pDetailsEx3->m_sAcknowledgedDialstring;
                            SysFreeString(pDetailsEx3->m_sAcknowledgedDialstring);
                        }
                        else
                        {
                            m_szSelectedLineDialed=_T("");
                        }

                        if(pDetailsEx3->m_sChargingDetails)
                        {
                            m_szSelectedLineCharging=pDetailsEx3->m_sChargingDetails;
                            SysFreeString(pDetailsEx3->m_sChargingDetails);
                
                        }
                        else
                        {
                            m_szSelectedLineCharging=_T("");
                        }

                        if(pDetailsEx3->m_sBlindCallTransferSourceNumber)
                        {
                            SysFreeString(pDetailsEx3->m_sBlindCallTransferSourceNumber);
                        }

                        if(pDetailsEx3->m_sBlindCallTransferSourceName)
                        {
                            SysFreeString(pDetailsEx3->m_sBlindCallTransferSourceName);
                        }

                        if(pDetailsEx3->m_sCalledExtension)
                        {
                            SysFreeString(pDetailsEx3->m_sCalledExtension);
                        }

                        if(pDetailsEx3->m_sCalledName)
                        {
                            SysFreeString(pDetailsEx3->m_sCalledName);
                        }

                        if(pDetailsEx3->m_sPeerNumber)
                        {
                            m_szSelectedLinePeerNumber=pDetailsEx3->m_sPeerNumber;
                            SysFreeString(pDetailsEx3->m_sPeerNumber);
                        }
                        else
                        {
                            m_szSelectedLinePeerNumber=_T("");
                        }

                        if(pDetailsEx3->m_sPeerName)
                        {
                            m_szSelectedLinePeerName=pDetailsEx3->m_sPeerName;
                            SysFreeString(pDetailsEx3->m_sPeerName);
                        }
                        else
                        {
                            m_szSelectedLinePeerName=_T("");
                        }

                        if(pDetailsEx3->m_sRedirectedFromName)
                        {
                            SysFreeString(pDetailsEx3->m_sRedirectedFromName);
                        }

                        if(pDetailsEx3->m_sRedirectedFromNumber)
                        {
                            SysFreeString(pDetailsEx3->m_sRedirectedFromNumber);
                        }
            
                        for(int i=pDetailsEx3->m_NumHistoryItems-1; i>=0; i--)
                        {
                            CString sNumber, sName, sPeer, sReason;
                            CTime   tTimestamp=CTime::GetCurrentTime();
                            CString sEventDescriptionFull;

                            if(pDetailsEx3->m_CallHistoryItems[i].m_Timestamp.year)
                            {
                                tTimestamp=CTime(   pDetailsEx3->m_CallHistoryItems[i].m_Timestamp.year,
                                                    pDetailsEx3->m_CallHistoryItems[i].m_Timestamp.month,
                                                    pDetailsEx3->m_CallHistoryItems[i].m_Timestamp.day,
                                                    pDetailsEx3->m_CallHistoryItems[i].m_Timestamp.hour,
                                                    pDetailsEx3->m_CallHistoryItems[i].m_Timestamp.minute,
                                                    pDetailsEx3->m_CallHistoryItems[i].m_Timestamp.second);
                            }

                            if(pDetailsEx3->m_CallHistoryItems[i].m_PeersNumber)
                            {
                                sNumber=pDetailsEx3->m_CallHistoryItems[i].m_PeersNumber;
                                SysFreeString(pDetailsEx3->m_CallHistoryItems[i].m_PeersNumber);
                                pDetailsEx3->m_CallHistoryItems[i].m_PeersNumber=NULL;
                            }
                        
                            if(pDetailsEx3->m_CallHistoryItems[i].m_PeersName)
                            {
                                sName=pDetailsEx3->m_CallHistoryItems[i].m_PeersName;
                                SysFreeString(pDetailsEx3->m_CallHistoryItems[i].m_PeersName);
                                pDetailsEx3->m_CallHistoryItems[i].m_PeersName=NULL;
                            }

                            if( (sName!="") && (sNumber!="") )
                            {
                                sPeer=sName+", "+sNumber;
                            }
                            else if(sName!="")
                            {
                                sPeer=sName;
                            }
                            else if(sNumber!="")
                            {
                                sPeer=sNumber;
                            }
                            else
                            {
                                sPeer="XXX";
                            }

                            switch(pDetailsEx3->m_CallHistoryItems[i].m_DiscReason)
                            {
                                case PubSCl3DRBusy:
                                    sReason.LoadString(IDS_DISC_BUSY);
                                    break;
                                case PubSCl3DRRejected:
                                    sReason.LoadString(IDS_DISC_REJECTED);
                                    break;
                                case PubSCl3DRCancelled:
                                    sReason.LoadString(IDS_DISC_CANCELLED);
                                    break;
                                case PubSCl3DRTransferred:
                                    sReason.LoadString(IDS_DISC_TRANSFERRED);
                                    break;
                                case PubSCl3DRJoinedConference:
                                    sReason.LoadString(IDS_DISC_JOINEDCONFERENCE);
                                    break;
                                case PubSCl3DRNoAnswer:
                                    sReason.LoadString(IDS_DISC_NOANSWER);
                                    break;
                                case PubSCl3DRTooLate:
                                    sReason.LoadString(IDS_DISC_TOOLATE);
                                    break;
                                case PubSCl3DRDirectCallImpossible:
                                    sReason.LoadString(IDS_DISC_DIRECTCALLIMPOSSIBLE);
                                    break;
                                case PubSCl3DRWrongNumber:
                                    sReason.LoadString(IDS_DISC_WRONGNUMBER);
                                    break;
                                case PubSCl3DRUnreachable:
                                    sReason.LoadString(IDS_DISC_UNREACHABLE);
                                    break;
                                case PubSCl3DRCallDiverted:
                                    sReason.LoadString(IDS_DISC_REDIRECTED);
                                    break;
                                case PubSCl3DRCallRoutingFailed:
                                    sReason.LoadString(IDS_DISC_ROUTING_FAILED);
                                    break;
                                case PubSCl3DRPermissionDenied:
                                    sReason.LoadString(IDS_DISC_PERMISSION_DENIED);
                                    break;
                                case PubSCl3DRNetworkCongestion:
                                    sReason.LoadString(IDS_DISC_NETWORKCONGESTION);
                                    break;
                                case PubSCl3DRNoChannelAvailable:
                                    sReason.LoadString(IDS_DISC_NOCHANNELAVAILABLE);
                                    break;
                                case PubSCl3DRNumberChanged:
                                    sReason.LoadString(IDS_DISC_NUMBERCHANGED);
                                    break;
                                case PubSCl3DRIncompatibleDestination:
                                    sReason.LoadString(IDS_DISC_INCOMPATIBLEDESTINATION);
                                    break;
                                case PubSCl3DRNormal:
                                default:
                                    sReason.LoadString(IDS_DISC_NORMAL);
                                    break;
                            }


                            switch(pDetailsEx3->m_CallHistoryItems[i].m_HistoryItemType)
                            {
                                case PubHITIncomingCall:
                                    sEventDescriptionFull.FormatMessage(IDS_CALLHISTORY_INCOMINGCALL, sPeer);
                                    break;
                                
                                case PubHITOutgoingCall:
                                    sEventDescriptionFull.LoadString(IDS_CALLHISTORY_OUTGOINGCALL);
                                    break;

                                case PubHITConnect:
                                    sEventDescriptionFull.FormatMessage(IDS_CALLHISTORY_CONNECT, sPeer);
                                    break;
                                
                                case PubHITHold:
                                    sEventDescriptionFull.LoadString(IDS_CALLHISTORY_HOLD);
                                    break;
                                
                                case PubHITConference:
                                    sEventDescriptionFull.LoadString(IDS_CALLHISTORY_CONFERENCE);
                                    break;
                                
                                case PubHITTransferCall:
                                    sEventDescriptionFull.FormatMessage(IDS_CALLHISTORY_TRANSFER, sPeer);
                                    break;

                                case PubHITTransferFailed:
                                    sEventDescriptionFull.FormatMessage(IDS_CALLHISTORY_TRANSFERFAILED, sReason);
                                    break;

                                case PubHITBlindTransferCall:
                                    sEventDescriptionFull.FormatMessage(IDS_CALLHISTORY_TRANSFER, sPeer);
                                    break;

                                case PubHITBlindTransferFailed:
                                    sEventDescriptionFull.FormatMessage(IDS_CALLHISTORY_TRANSFERFAILED, sReason);
                                    break;

                                case PubHITDisconnect:
                                    sEventDescriptionFull.FormatMessage(IDS_CALLHISTORY_DISCONNECT, sReason);
                                    break;
                            }

                            if(sEventDescriptionFull!="")
                            {
                                if(i==pDetailsEx3->m_NumHistoryItems-1)
                                {
                                    m_szCallHistory=tTimestamp.Format("%X ")+sEventDescriptionFull;
                                }
                                else
                                {
                                    m_szCallHistory+=CString("\r\n")+tTimestamp.Format("%X ")+sEventDescriptionFull;
                                }
                            }
                        }
                    }

                    CoTaskMemFree(pDetailsEx3);
                    pDetailsEx3=NULL;
                }

                pIClientLinePub2->Release();
                pIClientLinePub2=NULL;

            }
            else
            {
                //SwyxIt! < 4.10

                //get acknowledged dialstring (string that has been dialed so far)
                PubCLMgrLineDetails Details;

                hr=m_pISelectedLine->PubGetDetails(&Details);

                if(Details.m_sAcknowledgedDialstring)
                {
                    m_szSelectedLineDialed=Details.m_sAcknowledgedDialstring;
                }

                if(Details.m_sPeerNumber)
                {
                    m_szSelectedLinePeerNumber=Details.m_sPeerNumber;
                }

                if(Details.m_sPeerName)
                {
                    m_szSelectedLinePeerName=Details.m_sPeerName;
                }

                if(Details.m_sChargingDetails)
                {
                    m_szSelectedLineCharging=Details.m_sChargingDetails;
                }

                SysFreeString(Details.m_sAcknowledgedDialstring);
                SysFreeString(Details.m_sPeerNumber);
                SysFreeString(Details.m_sPeerName);
                SysFreeString(Details.m_sCalledExtension);
                SysFreeString(Details.m_sCalledName);
                SysFreeString(Details.m_sRedirectedFromNumber);
                SysFreeString(Details.m_sRedirectedFromName);
                SysFreeString(Details.m_sBlindCallTransferSourceNumber);
                SysFreeString(Details.m_sBlindCallTransferSourceName);
                SysFreeString(Details.m_sChargingDetails);
            }

        }
    }

    //init dialog with new data
    UpdateData(FALSE);
}



//there are details for a completed call available
void CMfcClientDlg::OnLastCallDetails(int iLine)
{
    //get data from dialog (in order to preserve dialstring)
    UpdateData(TRUE);

    //do something

    //init dialog with new data
    UpdateData(FALSE);
}



//the number of lines has changed
void CMfcClientDlg::OnNumberOfLinesChanged(int iNumberOfLines)
{
    HRESULT hr;

    //get data from dialog (in order to preserve dialstring)
    UpdateData(TRUE);
    
    //number of lines has changed!
    hr=m_pICLMgr->PubGetNumberOfLines((long*)&m_iNumberOfLines);

    //do we have pointer to line that is no more available?
    if(m_iSelectedLine>=m_iNumberOfLines)
    {
        if(m_pISelectedLine)
        {
            m_pISelectedLine->Release();
            m_pISelectedLine=NULL;
        }
        m_iSelectedLine=-1;
        //we will get message for changed selection anyway, so no more action required
    }

    //init dialog with new data
    UpdateData(FALSE);
}



void CMfcClientDlg::OnClientShutDownRequest()
{
    //get data from dialog (in order to preserve dialstring)
    UpdateData(TRUE);

    OnButtonLogoff();

    //init dialog with new data
    UpdateData(FALSE);
}
