/*---------------------------------------------------------------------------

   Swyx Solutions AG
   Joseph-von-Fraunhofer-Str. 13a
   44227 Dortmund

  ---------------------------------------------------------------------------

  THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY
  KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR
  PURPOSE.

  Copyright (C) 2007 Swyx Solutions AG.

  All Rights Reserved.

----------------------------------------------------------------------------*/

// MfcClientDlg.cpp : implementation file
//

#include "stdafx.h"




#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



//register window messages for signalling events to client
UINT glbWM_LineMgrNotification=RegisterWindowMessage(_T("WM_LineMgrNotification"));



CString CJob::Write()
{
    CString sRetries;
    CString sJob;

    sRetries.FormatMessage(_T("%1!d!"),m_iRetries);
    sJob=m_sPeerNumber+CString(_T(";"))+m_sForwardNumber+CString(_T(";"))+sRetries;

    return sJob;
}



bool CJob::Read(CString sJob)
{
    bool bRetVal=false;
    CString sPeerNumber;
    CString sForwardNumber;

    int iPos=sJob.Find(';');
    if(iPos>0)
    {
        sPeerNumber=sJob.Left(iPos);
        if(sJob.GetLength()-iPos-1>0)
        {
            sJob=sJob.Right(sJob.GetLength()-iPos-1);
        }
        else
        {
            sJob=_T("");
        }
    }
    iPos=sJob.Find(';');
    if(iPos>0)
    {
        sForwardNumber=sJob.Left(iPos);
        if(sJob.GetLength()-iPos-1>0)
        {
            sJob=sJob.Right(sJob.GetLength()-iPos-1);
        }
        else
        {
            sJob=_T("");
        }
    }
    if(sJob.GetLength()>0)
    {
        m_sPeerNumber=sPeerNumber;
        m_sForwardNumber=sForwardNumber;
        m_iRetries=atoi(sJob);
        bRetVal=true;
    }
    return bRetVal;
}






/////////////////////////////////////////////////////////////////////////////
// CMfcClientDlg dialog
CMfcClientDlg::CMfcClientDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMfcClientDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMfcClientDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

    //initialize interface pointer
    m_pICLMgr=NULL;
    m_iNumberOfLines=0;
    m_iTimerSchedule=0;
}



CMfcClientDlg::~CMfcClientDlg()
{
}



void CMfcClientDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMfcClientDlg)
	//}}AFX_DATA_MAP
}



BEGIN_MESSAGE_MAP(CMfcClientDlg, CDialog)
    //registered window message, send by client line manager
    ON_REGISTERED_MESSAGE(glbWM_LineMgrNotification, OnClientLineManagerEvent)

	//{{AFX_MSG_MAP(CMfcClientDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_START, OnButtonStart)
	ON_BN_CLICKED(IDC_BUTTON_STOP, OnButtonStop)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()



BOOL CMfcClientDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

    //feedback: enable / disable logon and logoff button
    GetDlgItem(IDC_BUTTON_START)->EnableWindow(TRUE);
    GetDlgItem(IDC_BUTTON_STOP)->EnableWindow(FALSE);
	
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}



// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.
void CMfcClientDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}



// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMfcClientDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}



//user clicked on button logon -> load line manager and register on server
void CMfcClientDlg::OnButtonStart()
{
    HRESULT hr;

    //get data from dialog
    UpdateData(TRUE);

    if(!m_pICLMgr)
    {
        //create line manager object on local machine
        hr=CoCreateInstance(CLSID_ClientLineMgr, NULL, CLSCTX_LOCAL_SERVER, IID_IClientLineMgrPub,(void**)&m_pICLMgr);

        if(SUCCEEDED(hr))
        {
            if(SUCCEEDED(hr))
            {
                //register our window as target for client line manager messages
                hr=m_pICLMgr->PubRegisterMessageTarget((long)m_hWnd, 0);

                hr=m_pICLMgr->PubGetNumberOfLines((long*)&m_iNumberOfLines);
                if(SUCCEEDED(hr) && (m_iNumberOfLines>0) )
                {
                    m_CurrentJobs.SetSize(m_iNumberOfLines);

                    //generate dummy jobs
                    CStdioFile  TextFile;

                    if(TextFile.Open(_T("JobsToDo.txt"), CFile::modeRead|CFile::shareExclusive|CFile::typeText))
                    {
                        CString sLine;
                        while(TextFile.ReadString(sLine))
                        {
                            CJob *pJob=new CJob();
                            if(pJob)
                            {
                                if(pJob->Read(sLine))
                                {
                                    m_ToDoList.Add(pJob);
                                }
                                else
                                {
                                    delete pJob;
                                }
                                pJob=NULL;
                            }
                        }
                        TextFile.Close();
                    }

                    /*
                    for(int i=0; i<10; i++)
                    {
                        CJob *pJob=new CJob(_T("102"), _T("100"));
                        if(pJob)
                        {
                            m_ToDoList.Add(pJob);
                            pJob=NULL;
                        }
                    }
                    */
                }

                //feedback: enable / disable logon and logoff button
                GetDlgItem(IDC_BUTTON_START)->EnableWindow(FALSE);
                GetDlgItem(IDC_BUTTON_STOP)->EnableWindow(TRUE);

                m_iTimerSchedule=SetTimer(TIMER_SCHEDULE, 5000, NULL);
            }
            else
            {
                m_pICLMgr->Release();
                m_pICLMgr=NULL;
            }
        }        
    }
}



//user clicked on button logoff -> unregister from server and release references to line manager
void CMfcClientDlg::OnButtonStop() 
{
    int i;

    CStdioFile  TextFile;
    bool        bTextFileOpen=false;

    if(m_iTimerSchedule)
    {
        KillTimer(m_iTimerSchedule);
        m_iTimerSchedule=0;
    }

    if(m_pICLMgr)
    {
        for(i=0; i<m_CurrentJobs.GetSize(); i++)
        {
            IClientLinePub *pIClientLine=NULL;

            HRESULT hr=m_pICLMgr->PubGetLine(i, &pIClientLine);

            if(SUCCEEDED(hr) && pIClientLine)
            {
                pIClientLine->PubHookOn();
                pIClientLine->Release();
                pIClientLine=NULL;
            }
        }

        m_pICLMgr->PubUnRegisterMessageTarget((long)m_hWnd, 0);
        m_pICLMgr->Release();
        m_pICLMgr=NULL;

        bTextFileOpen=false;
        if(TextFile.Open(_T("JobsToDo.txt"), CFile::modeCreate|CFile::modeWrite|CFile::shareExclusive|CFile::typeText))
        {
            bTextFileOpen=true;
        }
        for(i=0; i<m_ToDoList.GetSize(); i++)
        {
            CJob *pJob=(CJob*)m_ToDoList[i];

            if(pJob)
            {
                if(bTextFileOpen)
                {
                    CString sLine=pJob->Write();
                    sLine+=_T("\n");
                    TextFile.WriteString(sLine);
                }
                delete pJob;
            }
            m_ToDoList[i]=NULL;
        }
        m_ToDoList.RemoveAll();


        for(i=0; i<m_CurrentJobs.GetSize(); i++)
        {
            CJob *pJob=(CJob*)m_CurrentJobs[i];

            if(pJob)
            {
                if(bTextFileOpen)
                {
                    CString sLine=pJob->Write();
                    sLine+=_T("\n");
                    TextFile.WriteString(sLine);
                }
                delete pJob;
            }
            m_CurrentJobs[i]=NULL;
        }
        m_CurrentJobs.RemoveAll();
        if(bTextFileOpen)
        {
            TextFile.Close();
            bTextFileOpen=false;
        }


        bTextFileOpen=false;
        if(TextFile.Open(_T("JobsFinished.txt"), CFile::modeCreate|CFile::modeWrite|CFile::shareExclusive|CFile::typeText))
        {
            bTextFileOpen=true;
        }
        for(i=0; i<m_FinishedJobs.GetSize(); i++)
        {
            CJob *pJob=(CJob*)m_FinishedJobs[i];

            if(pJob)
            {
                if(bTextFileOpen)
                {
                    CString sLine=pJob->Write();
                    sLine+=_T("\n");
                    TextFile.WriteString(sLine);
                }
                delete pJob;
            }
            m_FinishedJobs[i]=NULL;
        }
        m_FinishedJobs.RemoveAll();
        if(bTextFileOpen)
        {
            TextFile.Close();
            bTextFileOpen=false;
        }
    }


    //feedback: enable / disable logon and logoff button
    GetDlgItem(IDC_BUTTON_START)->EnableWindow(TRUE);
    GetDlgItem(IDC_BUTTON_STOP)->EnableWindow(FALSE);
}



void CMfcClientDlg::OnDestroy() 
{
	OnButtonStop();

	CDialog::OnDestroy();
}



//used only in build targets "Win32 Debug" and "Win32 Release"
LRESULT CMfcClientDlg::OnClientLineManagerEvent(WPARAM wParam, LPARAM lParam)
{
    long            CLMgrMessage=wParam;
    _bstr_t         dialstring;
    int             iSignalledLine=-1;

    switch(CLMgrMessage)
    {
        case PubCLMgrLineStateChangedMessage:
            OnLineStateChanged(lParam);
            break;
            
        case PubCLMgrNumberOfLinesChangedMessage:
            //number of lines has changed!
            //this should not be -> stop working
        	OnButtonStop();
            break;

        case PubCLMgrClientShutDownRequest:
            //we are requested to logoff / release line manager
            //be a good client and do it! thanks!
        	OnButtonStop();
            break;

        case PubCLMgrLineDetailsChangedMessage:
        case PubCLMgrLineSelectionChangedMessage:
        case PubCLMgrCallDetailsMessage:
        case PubCLMgrGroupCallNotificationMessage:
        case PubCLMgrServerDownMessage:
        case PubCLMgrServerUpMessage:
        case PubCLMgrPowerSuspendMessage:
        case PubCLMgrPowerResumeMessage:
        case PubCLMgrUserDataChangedMessage:
        case PubCLMgrWaveDeviceChanged:
        case PubCLMgrHandsetStateChangedMessage:
        case PubCLMgrNameKeyStateChangedMessage:
        default:
            break;
    }

    return 0;
}



//state of a line has changed
void CMfcClientDlg::OnLineStateChanged(int iLine)
{
    HRESULT hr;

    if((iLine>=0) && (iLine<m_CurrentJobs.GetSize()))
    {
        IClientLinePub *pIClientLine=NULL;

        if(m_pICLMgr)
        {
            hr=m_pICLMgr->PubGetLine(iLine, &pIClientLine);

            if(SUCCEEDED(hr) && pIClientLine)
            {
                int iLineState=-1;

                //get new state
                hr=pIClientLine->PubGetState((long*)&iLineState);

                switch(iLineState)
                {
                    case PubLSActive:
                        {
                            //line is active -> transfer call
                            CJob *pJob=(CJob*)m_CurrentJobs[iLine];

                            if(pJob)
                            {
                                if(!pJob->m_bForwarded)
                                {
                                    _bstr_t bstrNumber=pJob->m_sForwardNumber;

                                    hr=pIClientLine->PubForwardCall(bstrNumber);
                                    if(hr==S_OK)
                                    {
                                        pJob->m_bForwarded=TRUE;
                                    }
                                }
                            }
                        }
                        break;

                    case PubLSTerminated:
                    case PubLSBusy:
                        {
                            //line is disconnected (terminated/busy)
                            //check disconnect reason
                            PubCLMgrLineDetails Details;
                            memset(&Details, 0, sizeof(PubCLMgrLineDetails));

                            hr=pIClientLine->PubGetDetails(&Details);

                            if(hr==S_OK)
                            {
                                SysFreeString(Details.m_sAcknowledgedDialstring);
                                SysFreeString(Details.m_sPeerNumber);
                                SysFreeString(Details.m_sPeerName);
                                SysFreeString(Details.m_sCalledExtension);
                                SysFreeString(Details.m_sCalledName);
                                SysFreeString(Details.m_sRedirectedFromNumber);
                                SysFreeString(Details.m_sRedirectedFromName);
                                SysFreeString(Details.m_sBlindCallTransferSourceNumber);
                                SysFreeString(Details.m_sBlindCallTransferSourceName);
                                SysFreeString(Details.m_sChargingDetails);
                            }
                            else
                            {
                                Details.m_DiscReason=PubSCl2DRNormal;
                            }

                            CJob *pJob=(CJob*)m_CurrentJobs[iLine];

                            if(pJob)
                            {
                                pJob->m_iDiscReason=Details.m_DiscReason;
                                if( pJob->m_bForwarded && (pJob->m_iDiscReason==PubSCl2DRTransferred) )
                                {
                                    //line is terminated because of successful transfer
                                    pJob->m_bDone=TRUE;

                                    //move to finished job list
                                    m_CurrentJobs[iLine]=NULL;
                                    m_FinishedJobs.Add(pJob);
                                    pJob=NULL;
                                }
                                else
                                {
                                    //any other disconnect reason, job failed
                                    pJob->m_bDone=FALSE;

                                    //put back to todo list
                                    m_CurrentJobs[iLine]=NULL;
                                    m_ToDoList.Add(pJob);
                                    pJob=NULL;
                                }
                            }
                        }
                        break;

                    case PubLSInactive:
                        {
                            //because of automatic hook on lines might become inactive very fast,
                            //so we could miss the terminated/busy state
                            if(m_CurrentJobs[iLine])
                            {
                                CJob *pJob=(CJob*)m_CurrentJobs[iLine];

                                if(pJob)
                                {
                                    if(pJob->m_bDialed)
                                    {
                                        //ok, line has been offhook and number has been dialed
                                        //check disconnect reason of last call
                                        PubCLMgrCallDetails Details;
                                        memset(&Details, 0, sizeof(PubCLMgrCallDetails));

                                        hr=pIClientLine->PubGetLastCallDetails(&Details);

                                        if(hr==S_OK)
                                        {
                                            SysFreeString(Details.m_sLastCallLcrPrefix);
                                            SysFreeString(Details.m_sLastCallOriginatingExtension);
                                            SysFreeString(Details.m_sLastCallChargingDetails);
                                            SysFreeString(Details.m_sLastCallPeersPbxUserName);
                                            SysFreeString(Details.m_sLastCallPeersNumber);
                                        }
                                        else
                                        {
                                            Details.m_LastCallDiscReason=PubSCl2DRNormal;
                                        }

                                        pJob->m_iDiscReason=Details.m_LastCallDiscReason;
                                        if( pJob->m_bForwarded && (pJob->m_iDiscReason==PubSCl2DRTransferred) )
                                        {
                                            //line is inactive after successful transfer
                                            pJob->m_bDone=TRUE;

                                            //move to finished job list
                                            m_CurrentJobs[iLine]=NULL;
                                            m_FinishedJobs.Add(pJob);
                                            pJob=NULL;
                                        }
                                        else
                                        {
                                            //any other disconnect reason, job failed
                                            pJob->m_bDone=FALSE;

                                            //put back to todo list
                                            m_CurrentJobs[iLine]=NULL;
                                            m_ToDoList.Add(pJob);
                                            pJob=NULL;
                                        }
                                    }
                                    else if(pJob->m_bHookedOff)
                                    {
                                        //this indicates that pIClientLine->PubHookOff() succeeded, but line was not necessarily offhook
                                        //check timespan between PubHookOff() and now
                                        CTime now=CTime::GetCurrentTime();
                                        CTimeSpan delta=now-pJob->m_tHookedOff;

                                        if(delta>CTimeSpan(0,0,0,5))
                                        {
                                            //job present, line hooked hooked off, but not dialed within 5 seconds; strange
                                            //move back to todo list
                                            m_CurrentJobs[iLine]=NULL;
                                            m_ToDoList.Add(pJob);
                                            pJob=NULL;
                                        }
                                    }
                                    else
                                    {
                                        //job present, but not yet dialed or hooked off, this looks strange
                                        //move back to todo list
                                        m_CurrentJobs[iLine]=NULL;
                                        m_ToDoList.Add(pJob);
                                        pJob=NULL;
                                    }
                                }
                            }

                            if(m_CurrentJobs[iLine]==NULL)
                            {
                                //no job on this line -> start new job
                                //jobs left in todo list?
                                if(m_ToDoList.GetSize()>0)
                                {
                                    //dial on this line!
                                    CJob *pJob=(CJob*)m_ToDoList[0];
                                    m_ToDoList[0]=NULL;
                                    m_ToDoList.RemoveAt(0);

                                    if(pJob)
                                    {
                                        hr=E_FAIL;

                                        pJob->m_bDialed=FALSE;
                                        pJob->m_bForwarded=FALSE;
                                        pJob->m_iDiscReason=PubSCl2DRNormal;

                                        m_CurrentJobs[iLine]=pJob;

                                        hr=pIClientLine->PubHookOff();
                                        if(hr==S_OK)
                                        {
                                            pJob->m_bHookedOff=TRUE;
                                            pJob->m_tHookedOff=CTime::GetCurrentTime();
                                        }
                                        else
                                        {
                                            //put back to todo list
                                            m_CurrentJobs[iLine]=NULL;
                                            m_ToDoList.Add(pJob);
                                            pJob=NULL;
                                        }
                                    }
                                }
                            }
                        }
                        break;

                    case PubLSHookOffInternal:
                        {
                            //line is offhook -> dial
                            CJob *pJob=(CJob*)m_CurrentJobs[iLine];

                            if(pJob)
                            {
                                if(!pJob->m_bDialed)
                                {
                                    _bstr_t bstrNumber=pJob->m_sPeerNumber;

                                    hr=pIClientLine->PubDial(bstrNumber);
                                    if(hr==S_OK)
                                    {
                                        pJob->m_bDialed=TRUE;
                                        pJob->m_tDialed=CTime::GetCurrentTime();
                                        pJob->m_iRetries++;
                                    }
                                }
                            }
                        }
                        break;

                    case PubLSRinging:
                    case PubLSDirectCall:
                    case PubLSDisabled:
                        if(m_CurrentJobs[iLine])
                        {
                            //there should not be a job in this state
                            CJob *pJob=(CJob*)m_CurrentJobs[iLine];

                            if(pJob)
                            {
                                //move back to todo list
                                m_CurrentJobs[iLine]=NULL;
                                m_ToDoList.Add(pJob);
                                pJob=NULL;
                            }
                        }
                        break;

                    case PubLSOnHold:
                    case PubLSConferenceActive:
                    case PubLSConferenceOnHold:
                        {
                            if(m_CurrentJobs[iLine])
                            {
                                //there should not be a job in this state; try again later
                                CJob *pJob=(CJob*)m_CurrentJobs[iLine];

                                if(pJob)
                                {
                                    //move back to todo list
                                    m_CurrentJobs[iLine]=NULL;
                                    m_ToDoList.Add(pJob);
                                    pJob=NULL;
                                }
                            }
                            hr=pIClientLine->PubHookOn();
                        }
                        break;

                    case PubLSHookOffExternal:
                    case PubLSDialing:
                    case PubLSAlerting:
                    case PubLSKnocking:
                    case PubLSTransferring:
                    default:
                        break;
                }

                pIClientLine->Release();
                pIClientLine=NULL;
            }
        }
    }
}



void CMfcClientDlg::OnTimer(UINT nIDEvent) 
{
    int     i;

	switch(nIDEvent)
    {
        case TIMER_SCHEDULE:
            //jobs left?
            if(m_ToDoList.GetSize()>0)
            {
                //look for line without job
                for(i=0; i<m_CurrentJobs.GetSize(); i++)
                {
                    //fake line state changed event -> trigger inactive lines for getting new job
                    if(m_CurrentJobs[i]==NULL)
                    {
                        OnLineStateChanged(i);
                    }
                }
            }
            break;

        default:
    	    CDialog::OnTimer(nIDEvent);
            break;
    }
}
